function [ model,sortedtech ] = handle_data( list_X,list_T,Data_X,Data_T,amount_fractions, inhab )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

% MAKE LIST FOR X
list_X( :, all( isnan(list_X), 1 ) ) = []; %this delete NaN columns
list_X(any(isnan(list_X),2),:)=[]; %this delete rows
list_T( :, all( isnan(list_T), 1 ) ) = []; %this delete NaN columns
Data_T(any(Data_T(:,1)==3,2),:)=[]; %this delete rows where Data_T(:,3)==3 (blue rows in excel)
%Data_T(any(isnan(Data_T),2),:)=[];
list_T(any(isnan(list_T),2),:)=[]; %this delete rows

new_Data_X=Data_X(:,3:end);
new_Data_T=Data_T(:,3:end);

%make model stucture
for i=1:size(list_X)
    model(i).type = 'x';
    model(i).from = list_X(i,1);
    model(i).to = list_X(i,2);
end
clear i;
for i=1:size(list_T)
    model(i+size(list_X,1)).type = 't';
    model(i+size(list_X,1)).from = list_T(i,1);
    model(i+size(list_X,1)).to = list_T(i,2);
end
clear i;

%make units equal (in %)
for i=1:size(Data_X)
    if mod(i-1,amount_fractions+2)==0
        if Data_X(i,1)==3 %=kg/cap/yr
            new_Data_X(i,:)= new_Data_X(i,:)*inhab/1000; %make t/yr
        end
        total_current_X = new_Data_X(i,:);
        
    else
        if mod(i-1,amount_fractions+2)==1 %technogoly
            if Data_X(i,1)==3 %=kg/cap/yr
                new_Data_X(i,:)= new_Data_X(i,:)*inhab/1000; %make t/yr
            end
            if Data_X(i,1) ~= 1 % do nothing when already in %
                 new_Data_X(i,:)= new_Data_X(i,:)./total_current_X;
            end
            total_current_technology = total_current_X.*new_Data_X(i,:);
        else %fractions
            for j=1:size(new_Data_X,2)
                if Data_X(i,1)==3 %kg/cap/yr
                    %devide by 0 is not possible
                    if total_current_technology(j) == 0;
                        new_Data_X(i,j) = 0;
                    else
                        new_Data_X(i,j)= (new_Data_X(i,j)*inhab/1000)./total_current_technology(j); %in %
                    end
                else
                    if Data_X(i,1)==2 %t/yr
                        if total_current_technology(j) == 0;
                            new_Data_X(i,j) = 0;
                        else
                            new_Data_X(i,j)= new_Data_X(i,j)./total_current_technology(j); % in %
                        end
                    end
                end
            end
            
        end
    end
    
end
clear i;
clear j;

%which flow are we looking at?
flow = zeros(amount_fractions,size(new_Data_X,2));
techn = zeros(amount_fractions,size(new_Data_X,2));
transfer = zeros(amount_fractions,size(new_Data_T,2));
current_flow_X = Data_X(1,2);
current_flow_T = Data_T(1,2);
techn_index=1;

%calculate the total flow based on the different technologies
clear i 

for i=1:size(Data_X)
    if Data_X(i,2)==current_flow_X    
        if mod(i-1,(2+amount_fractions))==0 %total of the flow
            given_flow = new_Data_X(i,:);%+1 because of number column
            flow_index=1;
        else
            if mod(i-1,(2+amount_fractions)) == 1 %division of technologies
                given_tech = new_Data_X(i,:);
            else%mod>2 = fractions                
                flow(flow_index,:) = flow(flow_index,:) + given_flow.*given_tech.*new_Data_X(i,:);
                techn(flow_index,:)= given_flow.*given_tech.*new_Data_X(i,:);
                flow_index = flow_index+1;
                if mod(i,(2+amount_fractions))==0 %the last one of the fractions
                    if ~isnan(techn)
                        technology(techn_index).flow = current_flow_X;
                        technology(techn_index).value = techn;
                        techn_index = techn_index + 1;
                    end
                end
              
            end
        end
    end
    if or(Data_X(i,2)~= current_flow_X,i==size(Data_X,1)) %new or last flow
        
        for j=1:size(list_X)
            if(list_X(j,3)==current_flow_X)
                list_X_index = j;
                break
            end
        end
        for z=1:size(technology,2)
            if technology(z).flow == current_flow_X
                technology(z).index = j;
            end
        end
        
        current_flow_X=Data_X(i,2);%new current flow
        %mod should be = 0 so:
        given_flow = new_Data_X(i,:);%+1 because of number column
        flow_index=1;
        %export flow matrix to model structure
        model(list_X_index).value = flow;
        flow = zeros(amount_fractions,size(new_Data_X,2));
        
        
    end
end
 clear i;
 clear j;
 clear z;
 
 [~, order] = sort([technology(:).index],'ascend');
 sortedtech = technology(order);

%MAKE LIST FOR T

transfer_index=1;
for i=1:size(Data_T)
    if Data_T(i,2)==current_flow_T  
        transfer(transfer_index,:) = new_Data_T(i,:);
        transfer_index = transfer_index+1;
    end
    if or(Data_T(i,2)~= current_flow_T,i==size(Data_T,1)) %new or last flow
        for j=1:size(list_T)
            if(list_T(j,end)==current_flow_T)
                list_T_index = j;
                break
            end
        end
        current_flow_T=Data_T(i,2);
        
        model(list_T_index+size(list_X,1)).value = transfer;
        transfer = zeros(amount_fractions,size(new_Data_T,2));
        transfer_index = 1;
        transfer(transfer_index,:) = new_Data_T(i,:);
        transfer_index = transfer_index+1;
    end
end

end

