function [KPI] = indicators( model,process_category,bio_tr,rest_index, amount_fractions,amount_flows,dest_fr, company_level,energy_over)
%UNTITLED Summary of this function goes here

%total generated waste per fraction
index = 1;
[generated_fr, generated_matrix] = generated(amount_fractions,amount_flows,process_category,model);
KPI(index).name = 'generated';
KPI(index).matrix = generated_matrix;
KPI(index).fractions = generated_fr;

%Collection efficiency
index = 2;
[collected_fr, collected_matrix,eff_col_fr, eff_col_tot] = collected(amount_fractions,amount_flows,process_category,dest_fr,rest_index,model, generated_fr);
KPI(index).name = 'collected';
KPI(index).matrix = collected_matrix;
KPI(index).fractions = collected_fr;
KPI(index).eff_fr =eff_col_fr;
KPI(index).eff_tot = eff_col_tot;

% sorting effeciency
index = 3;
[sorting_fr, sorting_matrix,eff_sort_fr, eff_sort_tot] = sorted(amount_fractions,amount_flows,process_category,model,generated_fr,rest_index);
KPI(index).name = 'sorted';
KPI(index).matrix = sorting_matrix;
KPI(index).fractions = sorting_fr;
KPI(index).eff_fr =eff_sort_fr;
KPI(index).eff_tot = eff_sort_tot;

%Material recycling efficiency
index = 4;
[recycling_fr,recycling_matrix, eff_recyc_fr, eff_recyc_tot] = recycled(amount_fractions,amount_flows,process_category,bio_tr,model,generated_fr);
KPI(index).name = 'recycled';
KPI(index).matrix = recycling_matrix;
KPI(index).fractions = recycling_fr;
KPI(index).eff_fr =eff_recyc_fr;
KPI(index).eff_tot = eff_recyc_tot;

%company matrix
index = 5;
[company_fr,company_matrix,eff_company_fr,eff_company_tot] = company(amount_fractions,amount_flows,model,generated_fr,company_level); %100% organic sent to biological treatment
%[company_fr,company_matrix,eff_company_fr,eff_company_tot] = company2(amount_fractions,amount_flows,model,generated_fr,company_level,bio_tr); % DM correction for organic matter sent to biological
KPI(index).name = 'Roaf';
KPI(index).matrix = company_matrix;
KPI(index).fractions = company_fr;
KPI(index).eff_fr =eff_company_fr;
KPI(index).eff_tot = eff_company_tot;

%Energy eff
index = 6;
[energy_eff, energy_overview] = energy(energy_over);
KPI(index).name = 'energy';
KPI(index).matrix = energy_over; %struct
KPI(index).fractions = energy_overview;
KPI(index).eff_tot = energy_eff;

%incineration matrix
index = 7;
[incineration_matrix] = incinerated(amount_fractions,amount_flows,model);
KPI(index).name = 'incinerated';
KPI(index).matrix = incineration_matrix;

end

function [generated_fr,generated_matrix] = generated(amount_fractions,amount_flows,process_category,model)
generated_fr = zeros(amount_fractions,1);
generated_matrix = zeros(amount_fractions,amount_flows);
for i=1:size(process_category(:,1))
    for j=1:size(model,2)
        if and(process_category(i,1)==model(j).to,model(j).from == 0)
            if model(j).type =='x'
                generated_matrix = generated_matrix + model(j).value;
                generated_fr = generated_fr + sum(model(j).value,2);
            end
        end
    end
end
end

function[collected_fr, collected_matrix, eff_col_fr, eff_col_tot] = collected(amount_fractions,amount_flows,process_category,dest_fr,rest_index,model, generated_fr)
collected_matrix = zeros(amount_fractions,amount_flows);
dest_fr(isnan(dest_fr))=0;
if size(dest_fr)< amount_fractions
    difference = amount_fractions-size(dest_fr,1);
    for z=1:difference
       dest_fr(size(dest_fr,1)+1,1) = 0;
    end
end

for j=1:size(process_category(:,1))%sorting=to
    for t=1:size(model,2)
        if and(0 ==model(t).from,process_category(j,1)==model(t).to)
             if model(t).type == 'x'
                 collected_matrix = collected_matrix + model(t).value;
             end
        end
    end
end
collected_fr=sum(collected_matrix.*dest_fr,2);
%sum(collected_matrix)
eff_col_fr = collected_fr./generated_fr;
collected_fr(rest_index) = 0 ;% not include rest
eff_col_tot = sum(collected_fr)/sum(sum(dest_fr,2).*generated_fr);% 
clear t;
end

function[sorting_fr, sorting_matrix,eff_sort_fr,eff_sort_tot] = sorted(amount_fractions,amount_flows,process_category,model,generated_fr,rest_index)
sorting_matrix = zeros(amount_fractions,amount_flows);
for i=1:size(process_category(:,2))%recycling              
    for j=1:size(model,2)
        if model(j).type == 'x'
            if process_category(i,2)==model(j).to%inflow in final process (incl max not recycled)
                sorting_matrix = sorting_matrix + model(j).value;
            end
        else            
            break
        end
    end
end
sorting_matrix(rest_index,:) = 0; % no rest sent for intention to recycling
sorting_fr = sum(sorting_matrix,2);
eff_sort_fr = sorting_fr./generated_fr;
eff_sort_tot = sum(sorting_fr)/sum(generated_fr);
end

function[recycling_fr,recycling_matrix, eff_recyc_fr, eff_recyc_tot] = recycled(amount_fractions,amount_flows,process_category,bio_tr,model,generated_fr)
recycling_matrix = zeros(amount_fractions,amount_flows);
for i=1:size(process_category(:,3))%recycling              
    for j=1:size(model,2)
        if model(j).type == 'x'
            if process_category(i,3)==model(j).to
                for t=1:size(bio_tr,1) %if multiple bio treatment processes
                    if bio_tr(t,1) == model(j).from % from a bio process to a recycling market
                        if size(bio_tr,2)<4 % energy market not filled in => only composting
                            AD_in = model(j).value;
                        else
                            for z=1:size(model,2)% can be changed if energy markets are zero
                                if model(z).type =='x'
                                    if and(model(z).from == model(j).from,model(z).to == bio_tr(t,4)) % to energy market
                                        AD_in = model(j).value + model(z).value;
                                    end
                                end
                            end
                            recycling_matrix = recycling_matrix + AD_in.*(bio_tr(t,2)/bio_tr(t,3));
                        end
                    else
                        recycling_matrix = recycling_matrix + model(j).value;
                    end
                end
            end
        else            
            break
        end
    end
end          
recycling_fr = sum(recycling_matrix,2);
eff_recyc_fr = recycling_fr./generated_fr;
eff_recyc_tot = sum(recycling_fr)/sum(generated_fr);
end

function[incineration_matrix] = incinerated(amount_fractions,amount_flows,model)
incineration_matrix = zeros(amount_fractions,amount_flows);            
for j=1:size(model,2)
    if model(j).type == 'x'
        if model(j).to == 8 %inflow in final process (incl max not recycled)
            incineration_matrix = incineration_matrix + model(j).value;
        end
    else            
        break
    end
end 
end

function[energy_eff,energy_overview] = energy(energy_over)    
    
    energy_overview(1,1)= energy_over(1).value;%feedstock
    energy_overview(2,1) = energy_over(2).value;%transport
    energy_overview(3,1) = energy_over(3).value;%process
    energy_eff = energy_over(4).value/sum(energy_overview(:,1));
    energy_overview(4,1) = energy_over(4).value;%out
end

function[company_fr,company_matrix,eff_company_fr,eff_company_tot] = company(amount_fractions,amount_flows,model,generated_fr,company_level)
company_matrix = zeros(amount_fractions,amount_flows);
for k=1:size(company_level,2)
    for i=1:size(company_level(:,k))%recycling              
        for j=1:size(model,2)
            if model(j).type == 'x'
                if company_level(i,k)==model(j).to %inflow in final process (incl max not recycled)
                    company_matrix(:,k) = company_matrix(:,k) + model(j).value(:,k);
                end
            else            
                break
            end
        end
    end
end
%company_matrix(rest_index,:) = 0; % no rest sent for intention to recycling
company_fr = sum(company_matrix,2);
eff_company_fr = company_fr./generated_fr;
eff_company_tot = sum(company_fr)/sum(generated_fr);
end

function[company_fr,company_matrix,eff_company_fr,eff_company_tot] = company2(amount_fractions,amount_flows,model,generated_fr,company_level,bio_tr)
company_matrix = zeros(amount_fractions,amount_flows);
for k=1:size(company_level,2)%horizontal
    for i=1:size(company_level(:,k))%vertical              
        for j=1:size(model,2)
            if model(j).type == 'x'
                if company_level(i,k)==model(j).to
                    for t=1:size(bio_tr,1) %if multiple bio treatment processes
                        if bio_tr(t,1) == company_level(i,k)
                            company_matrix(:,k) = company_matrix(:,k) + model(j).value(:,k).*(bio_tr(t,2)/bio_tr(t,3));
                        else
                            company_matrix(:,k) = company_matrix(:,k) + model(j).value(:,k);
                        end
                    end 
                end
            else            
                break
            end
        end
    end
end
company_fr = sum(company_matrix,2);
eff_company_fr = company_fr./generated_fr;
eff_company_tot = sum(company_fr)/sum(generated_fr);
end

